define(["dojo/_base/declare", "dojo/_base/config"], function(declare, config){
	var SharedProperties =  declare(null,{});
	SharedProperties.defaultStepEditorClass="com/sas/dm/datadirector/widgets/DefaultStepEditor";
	SharedProperties.defaultStepExecutionClass="com/sas/dm/datadirector/views/components/DefaultExecutionView";
	SharedProperties.defaultStepDiscoveryClass="com/sas/dm/datadirector/views/components/DefaultDiscoveryView";
	SharedProperties.defaultStepSummaryClass="com/sas/dm/datadirector/widgets/DefaultStepSummary";
	SharedProperties.defaultStepObserverClass="com/sas/dm/datadirector/observer/DefaultStepObserver";
	SharedProperties.defaultInlineSampleClass="com/sas/dm/datadirector/views/components/DefaultDataSampleView";
	SharedProperties.defaultInlinePreviewClass="com/sas/dm/datadirector/views/components/DefaultCodePreviewView";
	SharedProperties.defaultInlineModelAttributesClass="com/sas/dm/datadirector/views/components/ModelAttributesView";
	config.sas = config.sas || {};
	config.sas.commons = config.sas.commons || {};
	config.sas.commons.application = config.sas.commons.application || {};
	SharedProperties.contextRoot=config.sas.commons.application.contextPath+"/";
	
	SharedProperties.restType_Multipart="multipart/form-data";

	SharedProperties.uiMidTierURLPrefix="ui/";
	SharedProperties.restRootURL=SharedProperties.contextRoot+SharedProperties.uiMidTierURLPrefix;
	SharedProperties.defaultRootURL=SharedProperties.contextRoot+SharedProperties.uiMidTierURLPrefix+"DataLoader/";
	SharedProperties.helpURL="http://documentation.sas.com/#/";
	// 2.4
	// "http://support.sas.com/documentation/onlinedoc/dmdd/";
	// 2.1
	//"http://support.sas.com/documentation/solutions/dmdd/";
    SharedProperties.helpSoftwareId="dmddmid";
    SharedProperties.helpSoftwareVersion="3.1";
    // SharedProperties.preferencesServiceURL=SharedProperties.sharedServicesContextRoot+"rest/users/${0}/preferences";
	// SharedProperties.sharedServicesPingURL=SharedProperties.sharedServicesContextRoot+"rest/configuration/ping"
	SharedProperties.preferencesServiceURL=SharedProperties.restRootURL+"users/${0}/preferences";
	SharedProperties.sharedServicesPingURL=SharedProperties.restRootURL+"configuration/ping"
	SharedProperties.defaultTableViewerURL=SharedProperties.contextRoot+"tableviewer";
	SharedProperties.tableViewerParamFormat="?resource=path=${0}";
	SharedProperties.profileViewerContextRoot=config.sas.commons.application.ProfileViewerURL+"/";
    SharedProperties.profileReportViewerParamFormat="profile.jsp?jobid=${0}"
	SharedProperties.summarySeparator="  |  ";
    SharedProperties.summaryMultipleSeparator=" | ";
    SharedProperties.summaryListSeparator=", ";
	SharedProperties.summarySeparatorShort="|";
	SharedProperties.OutputMetadataKeyFormat = "${0}<${1}>"
	SharedProperties.executionStatus_Error = "FAILED";
	SharedProperties.executionStatus_Complete = "COMPLETED";
	SharedProperties.executionStatus_InProgress = "STARTED";
	SharedProperties.executionStatus_Abandoned = "ABANDONED";
	SharedProperties.executionStatus_Stopped = "STOPPED";
	SharedProperties.executionStatus_Stopping = "STOPPING";
	SharedProperties.executionStatus_Unknown = "UNKNOWN";
	SharedProperties.executionStatus_None = "NONE";
	SharedProperties.statusPollInterval = 2000;
	SharedProperties.runStatusPollInterval = 20000;  // 20 seconds
	SharedProperties.keepAliveTargets = [SharedProperties.contextRoot+"KeepAlive"];
	SharedProperties.applicationTimeoutPage = 'timeout';

	SharedProperties.defaultSASFolder = "SASFolderContentFileInfo=(name=My Folder)";
	
	//Column Types
	SharedProperties.column_TinyInt		= "tinyint";
	SharedProperties.column_SmallInt	= "smallint";
	SharedProperties.column_Integer		= "int";
	SharedProperties.column_BigInt		= "bigint";
	SharedProperties.column_Float		= "float";
	SharedProperties.column_Double		= "double";
	SharedProperties.column_Decimal		= "decimal";
	SharedProperties.column_String		= "string";
	SharedProperties.column_Varchar		= "varchar";
	SharedProperties.column_Char		= "char";
	SharedProperties.column_Boolean		= "boolean";
	SharedProperties.column_Binary		= "binary";
	SharedProperties.column_Array		= "array";
	SharedProperties.column_Map			= "map";
	SharedProperties.column_Struct		= "struct";
	SharedProperties.column_Union		= "uniontype";
	SharedProperties.column_Timestamp	= "timestamp";
	SharedProperties.column_Date		= "date";	
	//Oracle Column Types
	SharedProperties.columnOracle_Number 		= "number";
	SharedProperties.columnOracle_Salary 		= "salary";
	SharedProperties.columnOracle_VarChar2 		= "varchar2";
	SharedProperties.columnOracle_NVarChar2 	= "nvarchar2";
	SharedProperties.columnOracle_Long			= "long";
	SharedProperties.columnOracle_Date			= "date";
	SharedProperties.columnOracle_BinaryFloat	= "binary_float";
	SharedProperties.columnOracle_BinaryDouble 	= "binary_double";
	SharedProperties.columnOracle_TimeStamp		= "timestamp";
	SharedProperties.columnOracle_TimeStampWZone= "timestamp with time zone"; 
	SharedProperties.columnOracle_TimeStampeWLSone = "timestamp with local time zone"; 
	SharedProperties.columnOracle_IntervalYrToMnth = "interval year to month";
	SharedProperties.columnOracle_IntervalDyToScnd = "interval day to second";
	SharedProperties.columnOracle_Raw			= "raw";
	SharedProperties.columnOracle_LongRaw		= "long raw";
	SharedProperties.columnOracle_RowID			= "rowid";
	SharedProperties.columnOracle_URowID		= "urowid";
	SharedProperties.columnOracle_Char			= "char";
	SharedProperties.columnOracle_NChar			= "nchar";
	SharedProperties.columnOracle_Clob			= "clob";
	SharedProperties.columnOracle_NClob			= "nclob";
	SharedProperties.columnOracle_Blob			= "blob";
	SharedProperties.columnOracle_BFile			= "bfile";
	//Teradata Column Types
	SharedProperties.columnTeradata_ByteInt		= "byteint";
	SharedProperties.columnTeradata_Integer		= "integer";
	
	SharedProperties.column_Bit					= "bit";
	SharedProperties.column_Money				= "money";
	SharedProperties.column_SmallMoney			= "smallmoney";
	SharedProperties.column_Numeric				= "numeric";
	SharedProperties.column_Real				= "real";
	SharedProperties.column_DateTime			= "datetime";
	SharedProperties.column_nvarchar			= "nvarchar";
	SharedProperties.column_nvarcharmax			= "nvarchar(max)";
		
	//Predicate constants
	SharedProperties.predicate_IsEqual				= "IsEqual" ; 
	SharedProperties.predicate_IsNotEqual			= "IsNotEqual" ;
	SharedProperties.predicate_IsLessThan			= "IsLessThan" ;
	SharedProperties.predicate_IsGreaterThan		= "IsGreaterThan" ;
	SharedProperties.predicate_IsLessThanOrEqual	= "IsLessThanOrEqual" ;
	SharedProperties.predicate_IsGreaterThanOrEqual	= "IsGreaterThanOrEqual" ;
	SharedProperties.predicate_And					= "AllOf" ; 
	SharedProperties.predicate_Or					= "AnyOf" ;
	SharedProperties.predicate_IsNull				= "IsNull" ; 
	SharedProperties.predicate_IsNotNull			= "IsNotNull" ;
	SharedProperties.predicate_IsMissing			= "IsMissing" ;
	SharedProperties.predicate_IsNotMissing			= "IsNotMissing" ;
	SharedProperties.predicate_In					= "In" ;
	SharedProperties.predicate_NotIn				= "NotIn" ;
	SharedProperties.predicate_Like					= "Like" ;
	SharedProperties.predicate_Between				= "Between" ;
	SharedProperties.predicate_NotBetween			= "NotBetween" ;
	SharedProperties.predicate_Contains				= "Contains" ;
	SharedProperties.predicate_NotContains			= "NotContains" ;
	SharedProperties.predicate_Matches				= "Matches" ;
    SharedProperties.predicate_Not					= "Not" ;
    SharedProperties.predicate_Parens				= "Parens" ;
    SharedProperties.predicate_IsCaseInsensitive	= "IsCaseInsensitive" ;
    SharedProperties.predicate_AndOr	= "AndOr" ;
    SharedProperties.predicate_After				= "After";
    SharedProperties.predicate_Before				= "Before";
    SharedProperties.predicate_AfterIncludes		= "AfterIncludes";
    SharedProperties.predicate_BeforeIncludes		= "BeforeIncludes";
    SharedProperties.predicate_Min					= "Min";
    SharedProperties.predicate_Max					= "Max";
    SharedProperties.predicate_HighestOccurrence	= "HighestOccurrence";
    SharedProperties.predicate_LowestOccurrence		= "LowestOccurrence";
    SharedProperties.predicate_Longest				= "Longest";
    SharedProperties.predicate_Shortest				= "Shortest";

    //Operand constants
	SharedProperties.operand_CalculatedExpression	=	"CalculatedExpression" ;
	SharedProperties.operand_ConstantExpression		=	"ConstantExpression" ;
	SharedProperties.operand_DataItem				=	"DataItem" ;
	SharedProperties.operand_Column					=	"Column" ;
	SharedProperties.operand_OMRColumn				=	"OMRColumn" ;
	SharedProperties.operand_ComparisonCriteria		=	"ComparisonCriteria" ;
	SharedProperties.operand_CompoundCriteria		=	"CompoundCriteria" ;
	SharedProperties.operand_DataSelection			=	"DataSelection" ;
	SharedProperties.operand_CaseExpression			=	"CaseExpression" ;
	SharedProperties.operand_Values					=	"Values" ;
	SharedProperties.operand_FunctionExpression		=	"FunctionExpression" ;
	SharedProperties.operand_Predicate				=	"Predicate" ;
	
	//Aggregations
	SharedProperties.aggregation_allNumColumns = "allNumericColumns";
	SharedProperties.aggregation_allAggregations = "allAggregations";
	SharedProperties.aggregation_numeric = "numeric";
	SharedProperties.aggregation_all = "all";
	SharedProperties.aggregation_date = "datetime";
	
	SharedProperties.executionCodeKey = "CODE";
	SharedProperties.executionLogKey = "LOG";
	
	// Directive header action IDs
	SharedProperties.backToDirectivesActionId      = "backToDirectivesActionId";
	SharedProperties.saveActionId                  = "saveActionId";
	SharedProperties.saveAsActionId                = "saveAsActionId";
	SharedProperties.manageSavedDirectivesActionId = "manageSavedDirectivesActionId";
	SharedProperties.settingsActionId              = "settingsActionId";
	SharedProperties.advancedOptionsActionId       = "advancedOptionsId";
	
	//LASR Server Configuration Properties
	SharedProperties.lasrConfiguration_user		    = "sshuserid";
	SharedProperties.lasrConfiguration_default_user = "sasdldr1";
	SharedProperties.lasrConfiguration_signer		= "signer";
	SharedProperties.lasrConfiguration_sasiola      = "sasiola";
	SharedProperties.lasrConfiguration_tag			= "tag";
	SharedProperties.lasrConfiguration_metaserver	= "metaserver";
	SharedProperties.lasrConfiguration_metaport		= "metaport";
	SharedProperties.lasrConfiguration_metarepos	= "metarepository";
	SharedProperties.lasrConfiguration_omrfolder	= "omrfolder";
	SharedProperties.lasrConfiguration_omrlibrary	= "omrlibrary";
	
	// JDBC Server Configuration Properties
	SharedProperties.jdbcConfiguration_driver            = "driver";
	SharedProperties.jdbcConfiguration_connectstring     = "connection_string";
	SharedProperties.jdbcConfiguration_databaseName      = "database_name";
	SharedProperties.jdbcConfiguration_connectionManager = "connection_manager";
	SharedProperties.jdbcConfiguration_oracledriver      = "oracle.jdbc.OracleDriver";
	SharedProperties.jdbcConfiguration_teradatadriver    = "com.teradata.jdbc.TeraDriver";
	SharedProperties.jdbcConfiguration_federationdriver  = "com.sas.tkts.TKTSDriver";
	
	// User preferences
	SharedProperties.userPreference_DefaultLocale                 = "QKB_DEFAULTLOCALE";
	SharedProperties.userPreference_MarkNewDays                   = "MARKNEW_DAYS";
	SharedProperties.userPreference_MaxCharLen                    = "DBMAX_TEXT";
	SharedProperties.userPreference_OutputTableFormat             = "OUTPUT_TABLE_FORMAT";
	SharedProperties.userPreference_ProfileStopProcessing         = "PROFILE_STOP_PROCESSING";
	SharedProperties.userPreference_ProfileMaxFreqDist            = "PROFILE_MAX_FREQ_DIST";
	SharedProperties.userPreference_ProfileMaxOutliers            = "PROFILE_MAX_OUTLIERS";
	SharedProperties.userPreference_ProfileThreadCount			  = "PROFILE_THREAD_COUNT";
	SharedProperties.userPreference_ProfileMinMapReduceFlag		  = "PROFILE_MIN_MAPREDUCE_FLAG";
	SharedProperties.userPreference_RuleGenNumberOfRows           = "RULE_GEN_MAX_NUM_ROWS";
	SharedProperties.userPreference_Delimiter                     = "DELIMITER";
	SharedProperties.userPreference_FormatAndDelimiter            = "FORMAT_AND_DELIMITER";
	SharedProperties.userPreference_HadoopRecentTables            = "DL_HADOOP_RECENT_TABLES";
	SharedProperties.userPreference_ShowListView                  = "SHOW_LIST_VIEW";
	SharedProperties.userPreference_SavedSchema    	              = "DL_SAVED_SCHEMA";
	SharedProperties.userPreference_PersistHiveSchema	          = "DL_PERSIST_HIVE_SCHEMA";
	SharedProperties.userPreference_DeleteRecomputeFlag 		  = "DL_DELETE_RECOMPUTE_FLAG";
	SharedProperties.userPreference_PersistLastHDFSLocation		  = "DL_PERSIST_LAST_HDFS_LOCATION";
	SharedProperties.userPreference_PreferredRuntimeEnvironment	  = "DL_PREFERRED_RUNTIME_ENVIRONMENT";
	SharedProperties.userPreference_PreferredSQLEnvironment	      = "DL_PREFERRED_SQL_ENVIRONMENT";
	SharedProperties.userPreference_PersistLastSASFolder	      = "DL_PERSIST_LAST_SASFOLDER";
	SharedProperties.userPreference_LastSASFolder	      		  = "DL_LAST_SASFOLDER";
	SharedProperties.userPreference_PersistLastWSFolder	     	  = "DL_PERSIST_LAST_WORKSPACESERVER_FOLDER";
	SharedProperties.userPreference_LastWSFolder	      		  = "DL_LAST_WORKSPACESERVER_FOLDER";
	SharedProperties.userPreference_HiveTempSchema				  = "DL_HIVE_TEMP_SCHEMA";
	SharedProperties.userPreference_HiveStorageLocation 		  = "DL_HIVE_HDFS_STORAGE_LOCATION";
	SharedProperties.userPreference_SASHdfsTempLocation			  = "DL_SAS_HDFS_TEMP_LOCATION";
    SharedProperties.userPreference_PreferredSASWorkspaceServer      = "DL_PREFERRED_SAS_WORKSPACE_SERVER";

	// Common output keys
	SharedProperties.outputKey_AdvancedParameters				= "advancedParameters";
	SharedProperties.uiParam_InheritParentTableNameValidator 	= "inheritParentTableNameValidator";
	
	//Preferred SQL environments
	SharedProperties.preferredSqlEnvironment_default = "Default";
	SharedProperties.preferredSqlEnvironment_hive    = "Hive";
	SharedProperties.preferredSqlEnvironment_impala  = "Impala";
	// Directive properties
	SharedProperties.directiveProperty_PreferredExecutionEnvironment = "PREFERRED_EXECUTION_ENVIRONMENT";
	SharedProperties.directiveProperty_PreferredSQLEnvironment = "PREFERRED_SQL_ENVIRONMENT";
	// set this property when modifying the preferred execution environment from within the UI
	SharedProperties.directiveProperty_PreferredExecutionEnvironment_UI = "$PREFERRED_EXECUTION_ENVIRONMENT";
	SharedProperties.directiveProperty_PreferredSQLEnvironment_UI = "$PREFERRED_SQL_ENVIRONMENT";
	SharedProperties.directiveProperty_isSampleDirective = "isSampleDirective";
	
	//File types
	SharedProperties.outputTableFormat_sameAsSource   = "sameAsSource";
	SharedProperties.outputTableFormat_hiveDefault    = "hiveDefault";
	SharedProperties.outputTableFormat_text           = "text";
	SharedProperties.outputTableFormat_parquet        = "parquet";
	SharedProperties.outputTableFormat_orc            = "orc";
	SharedProperties.outputTableFormat_avro           = "avro";
	SharedProperties.outputTableFormat_sequence       = "sequence";
	
	//Delimiters
	SharedProperties.delimiter_source				  = "source";
	SharedProperties.delimiter_hive				  	  = "hive";
	SharedProperties.delimiter_comma				  = "comma";
	SharedProperties.delimiter_tab				      = "tab";
	SharedProperties.delimiter_space				  = "space";
	SharedProperties.delimiter_other				  = "other";
	
	// Join Types
	SharedProperties.join_inner	= "inner";
	SharedProperties.join_left	= "left";
	SharedProperties.join_right	= "right";
	SharedProperties.join_full	= "full";

	SharedProperties.dataType_Input = "input";
	SharedProperties.dataType_Output = "output";	
	SharedProperties.dataType_Parameter = "parameter";
	
	SharedProperties.outputKey_table = "selectedTables";
	
	SharedProperties.subviewId_dataSample = "dataSample";
	SharedProperties.subviewId_codePreview = "codePreview";
	SharedProperties.subviewId_modelAttributes = "modelAttributes";
	SharedProperties.stepUIParameter_showDataSample = "showDataSample";
	SharedProperties.stepUIParameter_showDownloadMenuAction = "showDownloadMenuAction";
	SharedProperties.stepUIParameter_showCodePreview = "showCodePreview";
	
	SharedProperties.existingTableOption_replace = "replace";
	SharedProperties.existingTableOption_append = "append";
	SharedProperties.existingTableOption_insertOverwrite = "insertOverwrite";
	SharedProperties.existingTableOption_noreplace = "noreplace";

	SharedProperties.dialect_DS2 = "ds2";
	SharedProperties.dialect_EEL = "eel";
	SharedProperties.dialect_Hive = "hive";
	SharedProperties.dialect_Impala = "impala";
	SharedProperties.dialect_outputKey = "dialect";
	
	SharedProperties.type_SASLibrary = "SASLibrary";
	SharedProperties.type_SASWorkspaceServer = "SASWorkspaceServer";
	SharedProperties.type_LASRServer = "LASRServer";
	
	SharedProperties.genericCacheKey_functionList = "functionMetadataList";
	
	SharedProperties.manageColumnsActiveView_advancedEditor = "advancedEditor";
	SharedProperties.manageColumnsActiveView_defaultEditor = "defaultEditor";
	
	SharedProperties.filterActiveView_specifyRules = "specifyRules";
	SharedProperties.filterActiveView_specifyExpression = "specifyExpression";
	SharedProperties.filterActiveView_allRows = "allRows";
	
	SharedProperties.manageColumnsValidationKey_columnName = "columnName";
	SharedProperties.manageColumnsValidationKey_columnType = "columnType";
	SharedProperties.manageColumnsValidationKey_columnLength = "columnLength";
	SharedProperties.manageColumnsValidationKey_Expression = "expression";
	SharedProperties.manageColumnsValidationKey_ColumnExpression = "columnExpression";
	
	SharedProperties.columnExpressionEditor_columnsPane = "columns";
	SharedProperties.columnExpressionEditor_functionsPane = "functions";
	SharedProperties.columnExpressionEditor_insertTextEvent = "inserttext";
	
	
	SharedProperties.maxLength_varchar = 65355;
	SharedProperties.maxLength_char = 255;
	
	SharedProperties.newColumn_defaultDisplaySize = 256;
	SharedProperties.newColumn_defaultTypeName = "VARCHAR";
	SharedProperties.newColumn_defaultIndex = -1;
	
	// Regrettably, Directive Types
	SharedProperties.directiveType_transformDataInHadoop = "DM_TRANSFORM_DATA_IN_HADOOP";
	SharedProperties.directiveType_transposeDataInHadoop = "DM_TRANSPOSE_DATA_IN_HADOOP";
	SharedProperties.directiveType_cleanseDataInHadoop = "DM_CLEANSE_DATA_IN_HADOOP";
	SharedProperties.directiveType_mergeData = "DM_MERGE_DATA";
	SharedProperties.directiveType_clusterSurviveInSpark = "DM_CLUSTER_SURVIVE_IN_SPARK";

	// Chained directive types
	SharedProperties.chainedDirectiveType_oldSerial = "DM_CHAIN_DIRECTIVES";
	SharedProperties.chainedDirectiveType_serial = "DM_CHAIN_DIRECTIVES_SERIAL";
	SharedProperties.chainedDirectiveType_parallel = "DM_CHAIN_DIRECTIVES_PARALLEL";	
    
	SharedProperties.executionEnvironmentInternalName_global = "EXECUTION_USE_GLOBAL_PREFERENCE";
    SharedProperties.executionEnvironmentInternalName_default = "DEFAULT_EXECUTION_ENVIRONMENT";
    SharedProperties.executionEnvironmentInternalName_architectHadoop = "DATAFLOW_HADOOP";
    SharedProperties.executionEnvironmentInternalName_architectSpark = "DATAFLOW_SPARK";
    SharedProperties.executionEnvironmentInternalName_architectCAS = "DATAFLOW_CAS";
    SharedProperties.executionEnvironmentInternalName_federationServer = "FEDERATION SERVER";
	SharedProperties.executionEnvironmentInternalName_spark2 = "SPARK2";

    SharedProperties.modelInputTypeText = "Text";
    SharedProperties.modelInputTypeNumeric = "Numeric";
    
    SharedProperties.serverType_FederationServer = "FederationJdbcServer";
    SharedProperties.serverType_HadoopServer = "HadoopServer";
    SharedProperties.serverType_HiveServer = "HadoopServer";
    SharedProperties.serverType_GenericJdbcServer = "JdbcServer";
    SharedProperties.serverType_OracleServer = "OracleJdbcServer";
    SharedProperties.serverType_SASWorkspaceServer = "SASWorkspaceServer";
    SharedProperties.serverType_TeradataServer = "TeradataJdbcServer";
    
    // events
    SharedProperties.refreshSubViews = "refreshSubViews";
    SharedProperties.closeSubViews = "closeSubViews";
    SharedProperties.scrollToStep = "scrollToStep";
    SharedProperties.leftHighlightedItemsChanged = "lefthighlighteditemschanged";
    SharedProperties.rightHighlightedItemsChanged = "righthighlighteditemschanged";
    SharedProperties.deleteTables = "deleteTable";
    SharedProperties.deleteFile = "deleteFile";

	SharedProperties.fileImportErrorCode_ColumnsDontMatch = "NUMBER DATA AND STRUCTURE COLUMNS DONT MATCH";
	SharedProperties.fileImportErrorCode_NumberColumnsVary = "NUMBER DATA COLUMNS VARY";
	SharedProperties.fileImportErrorCode_NumberValuesVary = "WARNING: The sample rows do not all have the same number of values.";
	SharedProperties.fileImportErrorCode_InvalidType = "INVALID_TYPE_DEFINITION";
	SharedProperties.fileImportErrorCode_MissingType = "MISSING_REQUIRED_TYPE_DEFINITION";
	SharedProperties.fileImportWarningCode_DelimiterChanged = "DELIMITER CHANGED";
	SharedProperties.fileImportWarningCode_UseFirstRowChanged = "USE FIRST ROW CHANGED";
	SharedProperties.fileImportWarningCode_NoSampleData = "NO SAMPLE DATA";
	
	// match rules
	SharedProperties.placeholder = "_$placeholder";
	SharedProperties.clusterActiveView_simpleRules = "clusterSimpleRules";
	SharedProperties.clusterActiveView_advancedRules = "clusterAdvancedRules";
	
	// survivor rules
	SharedProperties.survivorRecordActiveView_simpleRules = "survivorRecordSimpleRules";
	SharedProperties.survivorRecordActiveView_advancedRules = "survivorRecordAdvancedRules";
	SharedProperties.survivorRecordActiveView_noRules = "survivorRecordNoRules";
	SharedProperties.survivorValueText = "survivorValueText";
	SharedProperties.survivorValueTextList = "survivorValueTextList";
	SharedProperties.survivorValueColumn = "survivorValueColumn";
	SharedProperties.survivorValueDate = "survivorValueDate";
	SharedProperties.survivorColumnActiveView_simpleRules = "survivorColumnSimpleRules";
	SharedProperties.survivorColumnActiveView_advancedRules = "survivorColumnAdvancedRules";
	SharedProperties.survivorColumnActiveView_noRules = "survivorColumnNoRules";
	
	// library and server description keys
	SharedProperties.userLibraryDescription = "Location for User Data";
	SharedProperties.sampleLibraryDescription = "Location for Sample Data";
	SharedProperties.workspaceServerDescription = "SAS Workspace Server";
	
	// constants for object types
	SharedProperties.sasFolderType = "Folder";
	SharedProperties.sasUserFolderType = "UserFolder";
	SharedProperties.sasSystemFolderType = "SystemFolder";
	SharedProperties.sasJcrFolderType = "JcrFolder";
	SharedProperties.sasDirectiveType = "Directive.DL";
	SharedProperties.sasProfileType = "Profile";

	SharedProperties.dataSourceBrowserImport_pathOfLastResort="WSFolderContentFileInfo=(name=My Folder)";
	SharedProperties.dataSourceBrowserSavedDirectives_pathOfLastResort="SASFolderContentFileInfo=(name=/)";

	// application capabilities
	SharedProperties.capability_AdministerApplication = "AdministerApplication";

	// application properties
	SharedProperties.appProperty_QKBDefaultLocale = "sasdm.qkb.defaultlocale";

	SharedProperties.viewLibname_Preassigned = "PREASSIGNED_LIBNAME";

	return SharedProperties;
	
});
